unit u_main;
{  
DISCLAIMER
This software is free to use, copy or distrubute as a whole or in parts, as you like.
I, the author do not guarantee proper operation, suitability for any use,
  correctness of results, etc.....
I do not take any responsibility for misbehaviour of the software,
  including affecting the system on which it runs.
I can give some support regarding the operation of the program.
I cannot give any support for problems related to Free Pascal or Lazarus.
If you have such, visit the FPC and Lazarus forum(s).
This software was developed and tested on
  - WXP and W7 with FPC version 2.6.2 and Lazarus version 1.0.14.
  - Linux Mint with FPC version 2.6.4 and Lazarus version 1.4.2.
  
This software requires the packet lnet065 to be installed in the IDE.  

January 2019 jan@breem.nl
}

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs,
  ExtCtrls, StdCtrls, ComCtrls, lNetComponents, lNet;

type { TFrmMain }

  TFrmMain = class(TForm)
    ButtClrClipsLB: TButton;
    ButtClrClipsLMT: TButton;
    ButtClrClipsRB: TButton;
    ButtOpslaanFilter: TButton;
    ButtClrClipsRMT: TButton;
    CbxRstL: TCheckBox;
    CbxRstR: TCheckBox;
    CbxTalkToControlAmplifier: TCheckBox;
    CbxMuteBas: TCheckBox;
    CbxmuteMid: TCheckBox;
    CbxTalkToSpeakers: TCheckBox;
    Label26: TLabel;
    Label27: TLabel;
    Label28: TLabel;
    Label29: TLabel;
    Label30: TLabel;
    Label31: TLabel;
    Label32: TLabel;
    Label47: TLabel;
    Label48: TLabel;
    Label49: TLabel;
    Lbl50L: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Lbl12L: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    LbLFaultBL1: TLabel;
    LblFaultBR1: TLabel;
    LbLFaultMTL1: TLabel;
    LblFaultMTR1: TLabel;
    LblSpontaneousL: TLabel;
    LblSpontaneousR: TLabel;
    LbLFaultMTL: TLabel;
    LblFaultMTR: TLabel;
    Lblmin5L: TLabel;
    Lbl50R: TLabel;
    Lbl12R: TLabel;
    Lbl5L: TLabel;
    Lbl5R: TLabel;
    Lblmin5R: TLabel;
    LblRstTPAL: TLabel;
    Label36: TLabel;
    LblRstTPAR: TLabel;
    LblMainsFailL: TLabel;
    LblMainsFailR: TLabel;
    Label4: TLabel;
    Label40: TLabel;
    LblSupplyFailL: TLabel;
    LblSupplyFailR: TLabel;
    Label43: TLabel;
    LbLFaultBL: TLabel;
    LblFaultBR: TLabel;
    Label46: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    RbS1: TRadioButton;
    RbS2: TRadioButton;
    RbS3: TRadioButton;
    RbS4: TRadioButton;
    RbS5: TRadioButton;
    RbS6: TRadioButton;
    RbS7: TRadioButton;
    RbS8: TRadioButton;
    TbxCh1: TEdit;
    TbxCenter: TEdit;
    TbxControlIP: TEdit;
    TbxInMessageLength: TEdit;
    Tbx50L: TEdit;
    TbxClipsLMT: TEdit;
    TbxOutMessageLength: TEdit;
    TbxClipsRMT: TEdit;
    TbxRefL: TEdit;
    Tbx5DR: TEdit;
    Tbx12L: TEdit;
    Tbx5L: TEdit;
    Tbxmin5L: TEdit;
    Tbx5DL: TEdit;
    Tbx50R: TEdit;
    Tbx12R: TEdit;
    Tbx5R: TEdit;
    Tbxmin5R: TEdit;
    TbxExtra: TEdit;
    TbxBas: TEdit;
    TbxClipsLB: TEdit;
    TbxClipsRB: TEdit;
    TbxChannel: TEdit;
    TbxIR: TEdit;
    TbxRefR: TEdit;
    TbxVol: TEdit;
    TbxHeadPhone: TEdit;
    TbxOutMessageCount: TEdit;
    TbxMid: TEdit;
    TbxCh2: TEdit;
    TbxCh3: TEdit;
    TbxCh4: TEdit;
    TbxCh5: TEdit;
    TbxCh6: TEdit;
    TbxCh7: TEdit;
    TbxCh8: TEdit;
    TbxEffect: TEdit;
    TimerSend: TTimer;
    UDcenter: TUpDown;
    UDextra: TUpDown;
    UDbas: TUpDown;
    UDmid: TUpDown;
    UDch4: TUpDown;
    UDch5: TUpDown;
    UDch6: TUpDown;
    UDch7: TUpDown;
    UDch8: TUpDown;
    UDeffect: TUpDown;
    Udp: TLUDPComponent;
    TbxInMessageCount: TEdit;
    TbxOutMessage: TEdit;
    TbxInMessage: TEdit;
    UDch1: TUpDown;
    UDch2: TUpDown;
    UDch3: TUpDown;
    procedure ButtClrClipsLBClick(Sender: TObject);
    procedure ButtClrClipsLMTClick(Sender: TObject);
    procedure ButtOpslaanFilterClick(Sender: TObject);
    procedure ButtClrClipsRBClick(Sender: TObject);
    procedure ButtClrClipsRMTClick(Sender: TObject);
    procedure ButtZeroBassClick(Sender: TObject);
    procedure ButtZeroMidClick(Sender: TObject);
    procedure CbxTalkToSpeakersChange(Sender: TObject);
    procedure CbxRstLChange(Sender: TObject);
    procedure CbxTalkToControlAmplifierChange(Sender: TObject);
    procedure CbxRstRChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure TimerSendTimer(Sender: TObject);
    procedure UDbasClick(Sender: TObject; Button: TUDBtnType);
    procedure UDcenterClick(Sender: TObject; Button: TUDBtnType);
    procedure UDch1Click(Sender: TObject; Button: TUDBtnType);
    procedure UDch2Click(Sender: TObject; Button: TUDBtnType);
    procedure UDch3Click(Sender: TObject; Button: TUDBtnType);
    procedure UDch4Click(Sender: TObject; Button: TUDBtnType);
    procedure UDch5Click(Sender: TObject; Button: TUDBtnType);
    procedure UDch6Click(Sender: TObject; Button: TUDBtnType);
    procedure UDch7Click(Sender: TObject; Button: TUDBtnType);
    procedure UDch8Click(Sender: TObject; Button: TUDBtnType);
    procedure UDeffectClick(Sender: TObject; Button: TUDBtnType);
    procedure UDextraClick(Sender: TObject; Button: TUDBtnType);
    procedure UDmidClick(Sender: TObject; Button: TUDBtnType);
    procedure UdpReceive(aSocket: TLSocket);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  FrmMain: TFrmMain;

implementation
{$R *.lfm}

uses strutils, u_numstrings;

const
VersionString = '2019-01-22';
Port = 8000;

// Communication with Control Amplifier
const
  INMESSAGESIZE = 30;

var
OutMessage, InMessage : string;
Talk, TalkToSpeakers: boolean;

// Settings
Command,
Ch1, Ch2, Ch3, Ch4, Ch5, Ch6, Ch7, Ch8,
ChEffect, ChCenter, ChExtra, ChBas, ChMid: byte;
ControlIP: string; // IP of Control Amplifier
SettingsFilename: shortstring;

// Report
Channel, IRcode, Vol, Phn, StatusL, StatusR: byte;
AdcRefL, AdcRefR : integer;
V5DL, V50L, V12L, V5AL, Vmin5AL, V5DR, V50R, V12R, V5AR, Vmin5AR: real;
ClipsLB, ClipsLMT, ClipsRB, ClipsRMT: byte;

// Commands
CommandLeft, CommandRight: byte;
ResetLeftAmplifier, ResetRightAmplifier: boolean;

// Forwards
function PGAdB(code: byte): real; forward;

// *************************************************************************
// Communication, Messages

procedure DecodeInMessage;
begin
  with FrmMain do
  begin
    // Decompose message
    Channel:= byte(InMessage[1]);
    IRcode:= byte(InMessage[2]);
    Vol:= byte(InMessage[3]);
    Phn:= byte(InMessage[4]);
    // Message from left spkr
    StatusL:= byte(InMessage[5]);
    AdcRefL := StrLittleToUnSignedInt(Midstr(InMessage,6,2));
    V50L := StrLittleToUnSignedInt(Midstr(InMessage,8,2));
    V12L:= StrLittleToUnSignedInt(Midstr(InMessage,10,2));
    V5AL:= StrLittleToUnSignedInt(Midstr(InMessage,12,2));
    Vmin5AL:= StrLittleToSignedInt(Midstr(InMessage,14,2));
    ClipsLB:= byte(InMessage[16]);
    ClipsLMT:= byte(InMessage[17]);
    // Message from right spkr
    StatusR := byte(InMessage[18]);
    AdcRefR:= StrLittleToUnSignedInt(Midstr(InMessage,19,2)); // ADC value
    V50R:= StrLittleToUnSignedInt(Midstr(InMessage,21,2)); // mV
    V12R:= StrLittleToUnSignedInt(Midstr(InMessage,23,2)); // mV
    V5AR:= StrLittleToUnSignedInt(Midstr(InMessage,25,2)); // mV
    Vmin5AR:= StrLittleToSignedInt(Midstr(InMessage,27,2)); // mV
    ClipsRB:= byte(InMessage[29]);
    ClipsRMT:= byte(InMessage[30]);

    TbxChannel.text:= Format('%3d', [Channel]);
    TbxIR.text:= Format('%3d', [IRcode]);
    TbxVol.text:= Format('%3d', [Vol]);
    TbxHeadPhone.text:= Format('%3d', [Phn]);

    // Set radiobuttons according to Channel
    if Channel = 1 then RbS1.Checked:= true;
    if Channel = 2 then RbS2.Checked:= true;
    if Channel = 3 then RbS3.Checked:= true;
    if Channel = 4 then RbS4.Checked:= true;
    if Channel = 5 then RbS5.Checked:= true;
    if Channel = 6 then RbS6.Checked:= true;
    if Channel = 7 then RbS7.Checked:= true;
    if Channel = 8 then RbS8.Checked:= true;

    // From left loudspeaker
    TbxRefL.text:=      Format('%3d',   [AdcRefL]);
    if AdcRefL > 400 then  // prevent division by zero.
    V5DL:= 2.5 * 1024.0 / AdcRefL else V5DL:= 0;
    Tbx5DL.text:=       Format('%4.1f', [V5DL/1000]);
    Tbx50L.text:=       Format('%4.1f', [V50L/1000]);
    Tbx12L.text:=       Format('%4.1f', [V12L/1000]);
    Tbx5L.text:=        Format('%4.1f', [V5AL/1000]);
    Tbxmin5L.text:=     Format('%4.1f', [Vmin5AL/1000]);
    Tbx5DL.text:=       Format('%4.1f', [V5DL]);
    TbxClipsLB.text:=   Format('%3d',   [ClipsLB]);
    TbxClipsLMT.text:=  Format('%3d',   [ClipsLMT]);

    // Range check
    if(V50L < 40000) or (V50L > 55000) then Lbl50L.Color:=clRed else Lbl50L.Color:=clLime;
    if(V12L < 10000) or (V12L > 140000) then Lbl12L.Color:=clRed else Lbl12L.Color:=clLime;
    if(V5AL < 4000) or (V5AL > 6000) then Lbl5L.Color:=clRed else Lbl5L.Color:=clLime;
    if(Vmin5AL < -6000) or (Vmin5AL > -4000) then Lblmin5L.Color:=clRed else Lblmin5L.Color:=clLime;

    // Decode status
    if(StatusL and $01) = $01 then LblMainsFailL.Color:=clRed else LblMainsFailL.Color:=clLime;
    if(StatusL and $02) = $02 then LblSupplyFailL.Color:=clRed else LblSupplyFailL.Color:=clLime;
    if(StatusL and $04) = $04 then LbLFaultBL.Color:=clRed else LbLFaultBL.Color:=clLime;
    if(StatusL and $08) = $08 then LblFaultMTL.Color:=clRed else LblFaultMTL.Color:=clLime;
    if(StatusL and $10) = $10 then ButtClrClipsLB.Color:=clRed else ButtClrClipsLB.Color:=clDefault;
    if(StatusL and $20) = $20 then ButtClrClipsLMT.Color:=clRed else ButtClrClipsLMT.Color:=clDefault;
    if(StatusL and $40) = $40 then LblSpontaneousL.Color:=clRed else LblSpontaneousL.Color:=clLime;
    if(StatusL and $80) = $80 then LblRstTPAL.Color:=clRed else LblRstTPAL.Color:= clLime;

    // From right loudspeaker
    TbxRefR.text:=      Format('%3d',   [AdcRefR]);
    if AdcRefR > 400 then  // prevent division by zero.
    V5DR:= 2.5 * 1024.0 / AdcRefR else V5DR:= 0;
    Tbx5DR.text:=       Format('%4.1f', [V5DR/1000]);
    Tbx50R.text:=       Format('%4.1f', [V50R/1000]);
    Tbx12R.text:=       Format('%4.1f', [V12R/1000]);
    Tbx5R.text:=        Format('%4.1f', [V5AR/1000]);
    Tbxmin5R.text:=     Format('%4.1f', [Vmin5AR/1000]);
    Tbx5DR.text:=       Format('%4.1f', [V5DR]);
    TbxClipsRB.text:=   Format('%3d',   [ClipsRB]);
    TbxClipsRMT.text:=  Format('%3d',   [ClipsRMT]);

    // Range check
    if(V50R < 40000) or (V50R > 55000) then Lbl50R.Color:=clRed else Lbl50R.Color:=clLime;
    if(V12R < 10000) or (V12R > 14000) then Lbl12R.Color:=clRed else Lbl12R.Color:=clLime;
    if(V5AR < 4000) or (V5AR > 6000) then Lbl5R.Color:=clRed else Lbl5R.Color:=clLime;
    if(Vmin5Ar < -6000) or (Vmin5AR > -4000) then Lblmin5R.Color:=clRed else Lblmin5R.Color:=clLime;

    // Decode status
    if(StatusR and $01) = $01 then LblMainsFailR.Color:=clRed else LblMainsFailR.Color:=clLime;
    if(StatusR and $02) = $02 then LblSupplyFailR.Color:=clRed else LblSupplyFailR.Color:=clLime;
    if(StatusR and $04) = $04 then LblFaultBR.Color:=clRed else LblFaultBR.Color:=clLime;
    if(StatusR and $08) = $08 then LblFaultMTR.Color:=clRed else LblFaultMTR.Color:=clLime;
    if(StatusR and $10) = $10 then ButtClrClipsRB.Color:=clRed else ButtClrClipsRB.Color:=clDefault;
    if(StatusR and $20) = $20 then ButtClrClipsRMT.Color:=clRed else ButtClrClipsRMT.Color:=clDefault;
    if(StatusR and $40) = $40 then LblSpontaneousR.Color:=clRed else LblSpontaneousR.Color:=clLime;
    if(StatusR and $80) = $80 then LblRstTPAR.Color:=clRed else LblRstTPAR.Color:= clLime;
  end;
end;

procedure PrepareOutMessage;
var  CBas, CMid: byte;
begin
  with FrmMain do
  begin
    if CbxMuteBas.Checked then CBas := 0 else CBas := ChBas;
    if CbxMuteMid.Checked then CMid := 0 else CMid := ChMid;
    if TalkToSpeakers then Command:= Command or $01;
    if ResetLeftAmplifier then CommandLeft:= CommandLeft or $80;
    if ResetRightAmplifier then CommandRight:= CommandRight or $80;
    OutMessage := char(Command) +
    char(Ch1) + char(Ch2) + char(Ch3) + char(Ch4) +
    char(Ch5) + char(Ch6) + char(Ch7) + char(Ch8) +
    char(ChEffect) + char(ChCenter) + char(ChExtra) +
    char(CommandLeft) + char(CommandRight) +
    char(CBas) + char(CMid);
    Command:= 0;
    CommandLeft:= 0;
    CommandRight:= 0;
  end;
end;

procedure TFrmMain.UDPReceive(aSocket: TLSocket);
const InCount: byte = 0;
begin
  inc(InCount);
  TbxInMessageCount.text := Format('%4d', [Incount]);
  if aSocket.GetMessage(InMessage) > 0 then
  begin
    inc(InCount);
    TbxInMessageCount.text:= format('%3d',[InCount]);
    TbxInMessageLength.text:= format('%3d',[length(InMessage)]);
    TbxInMessage.text:= BytesView(InMessage, length(InMessage));
    if length(InMessage) = INMESSAGESIZE then DecodeInMessage;
  end;
end;

procedure TFrmMain.TimerSendTimer(Sender: TObject);
const OutCount: byte = 0;
begin
  if Talk then
  begin
    PrepareOutMessage;
    Udp.Connect(ControlIP, Port);
    Udp.SendMessage(OutMessage);
    Udp.Disconnect;
    Udp.listen(Port);
    inc(OutCount);
  end;
  TbxOutMessageCount.text:= format('%3d', [OutCount]);
  TbxOutMessageLength.text:= format('%5d', [length(OutMessage)]);
  TbxOutMessage.text:= BytesView(OutMessage, length(OutMessage));
end;

procedure TFrmMain.CbxTalkToControlAmplifierChange(Sender: TObject);
begin
  ControlIP:= TbxControlIP.text;
  Talk:= CbxTalkToControlAmplifier.checked = true;
  CbxTalkToSpeakers.Enabled := Talk;
  if not Talk then CbxTalkToSpeakers.Checked:= false;
end;

// ***************************************************************************
// Loudspeakers, both

procedure TFrmMain.UDbasClick(Sender: TObject; Button: TUDBtnType);
begin
  ChBas := UDbas.position;
  TbxBas.text := Format('%4.1f',[PGAdb(ChBas)]);
end;

procedure TFrmMain.ButtZeroBassClick(Sender: TObject);
begin
  UDbas.position:= 192; // 0dB
  ChBas := UDbas.position;
  TbxBas.text := Format('%4.1f',[PGAdb(ChBas)]);
end;

procedure TFrmMain.UDMidClick(Sender: TObject; Button: TUDBtnType);
begin
  ChMid := UDmid.position;
  TbxMid.text := Format ('%4.1f',[PGAdb(ChMid)]);
end;

procedure TFrmMain.ButtZeroMidClick(Sender: TObject);
begin
  UDmid.position := 192; // 0dB
  ChMid := UDmid.position;
  TbxMid.text := Format ('%4.1f',[PGAdb(ChMid)]);
end;

procedure TFrmMain.ButtOpslaanFilterClick(Sender: TObject);
begin
  CommandLeft := CommandLeft or $04; // Store in EEPROM on FLT
  CommandRight := CommandRight or $04;
end;

procedure TFrmMain.CbxTalkToSpeakersChange(Sender: TObject);
begin
   TalkToSpeakers:= CbxTalkToSpeakers.Checked;
end;

// ***************************************************************************
// Loudspeaker left

procedure TFrmMain.CbxRstLChange(Sender: TObject);
begin
  ResetLeftAmplifier:= CbxRstL.checked;
end;

procedure TFrmMain.ButtClrClipsLBClick(Sender: TObject);
begin
  CommandLeft := CommandLeft or $20;
end;

procedure TFrmMain.ButtClrClipsLMTClick(Sender: TObject);
begin
  CommandLeft := CommandLeft or $40;
end;

// ***************************************************************************
// Loudspeaker right

procedure TFrmMain.CbxRstRChange(Sender: TObject);
begin
  ResetRightAmplifier:= CbxRstR.checked;
end;

procedure TFrmMain.ButtClrClipsRBClick(Sender: TObject);
begin
  CommandRight:= CommandRight or $20;
end;

procedure TFrmMain.ButtClrClipsRMTClick(Sender: TObject);
begin
  CommandRight:= CommandRight or $40;
end;

// **************************************************************************
// convert PGA code to dB's.  see datasheet PGA2311
function PGAdB (code: byte): real;
begin
  PGAdB:= (code - 192) / 2;
end;

// **************************************************************************
// Correction channel sensitivity

procedure TFrmMain.UDch1Click(Sender: TObject; Button: TUDBtnType);
begin
  Ch1:= UDCh1.position;
  TbxCh1.text:= Format('%4.1f',[PGAdb(Ch1)]);
end;

procedure TFrmMain.UDch2Click(Sender: TObject; Button: TUDBtnType);
begin
  Ch2:= UDCh2.position;
  TbxCh2.text:= Format('%4.1f',[PGAdb(Ch2)]);
end;

procedure TFrmMain.UDch3Click(Sender: TObject; Button: TUDBtnType);
begin
  Ch3:= UDCh3.position;
  TbxCh3.text:= Format('%4.1f',[PGAdb(Ch3)]);
end;

procedure TFrmMain.UDch4Click(Sender: TObject; Button: TUDBtnType);
begin
  Ch4:= UDCh4.position;
  TbxCh4.text:= Format('%4.1f',[PGAdb(Ch4)]);
end;

procedure TFrmMain.UDch5Click(Sender: TObject; Button: TUDBtnType);
begin
  Ch5:= UDCh5.position;
  TbxCh5.text:= Format('%4.1f',[PGAdb(Ch5)]);
end;

procedure TFrmMain.UDch6Click(Sender: TObject; Button: TUDBtnType);
begin
    Ch6:= UDCh6.position;
  TbxCh6.text:= Format('%4.1f',[PGAdb(Ch6)]);
end;

procedure TFrmMain.UDch7Click(Sender: TObject; Button: TUDBtnType);
begin
  Ch7:= UDCh7.position;
  TbxCh7.text:= Format('%4.1f',[PGAdb(Ch7)]);
end;

procedure TFrmMain.UDch8Click(Sender: TObject; Button: TUDBtnType);
begin
  Ch8:= UDCh8.position;
  TbxCh8.text:= Format('%4.1f',[PGAdb(Ch8)]);
end;

procedure TFrmMain.UDeffectClick(Sender: TObject; Button: TUDBtnType);
begin
  ChEffect:= UDEffect.position;
  TbxEffect.text:= Format('%4.1f',[PGAdb(ChEffect)]);
end;

procedure TFrmMain.UDcenterClick(Sender: TObject; Button: TUDBtnType);
begin
  ChCenter:= UDCenter.position;
  TbxCenter.text:= Format('%4.1f',[PGAdb(ChCenter)]);
end;

procedure TFrmMain.UDextraClick(Sender: TObject; Button: TUDBtnType);
begin
  ChExtra:= UDExtra.position;
  TbxExtra.text:= Format('%4.1f',[PGAdb(ChExtra)]);
end;

// ***************************************************************************
// Store / retrieve settings

procedure WriteSettings;
var SettingsFile : text;
begin
  assign(SettingsFile, SettingsFileName);
  rewrite(SettingsFile);
  writeln(SettingsFile, Ch1);
  writeln(SettingsFile, Ch2);
  writeln(SettingsFile, Ch3);
  writeln(SettingsFile, Ch4);
  writeln(SettingsFile, Ch5);
  writeln(SettingsFile, Ch6);
  writeln(SettingsFile, Ch7);
  writeln(SettingsFile, Ch8);
  writeln(SettingsFile, ChEffect);
  writeln(SettingsFile, ChCenter);
  writeln(SettingsFile, ChExtra);
  writeln(SettingsFile, ChBas);
  writeln(SettingsFile, ChMid);
  writeln(SettingsFile, ControlIP);
  close(SettingsFile);
end;

procedure ReadSettings;
var SettingsFile : text;
p: TObject;
b: TUDBtnType;
begin
  if not FileExists(SettingsFileName) then exit;
  assign(SettingsFile, SettingsFileName);
  reset(SettingsFile);
  readln(SettingsFile, Ch1);
  readln(SettingsFile, Ch2);
  readln(SettingsFile, Ch3);
  readln(SettingsFile, Ch4);
  readln(SettingsFile, Ch5);
  readln(SettingsFile, Ch6);
  readln(SettingsFile, Ch7);
  readln(SettingsFile, Ch8);
  readln(SettingsFile, ChEffect);
  readln(SettingsFile, ChCenter);
  readln(SettingsFile, ChExtra);
  readln(SettingsFile, ChBas);
  readln(SettingsFile, ChMid);
  readln(SettingsFile, ControlIP);
  close(SettingsFile);
  with FrmMain do
  begin
    UDch1.position:= Ch1; UDch1Click(p, b);
    UDch2.position:= Ch2; UDch2Click(p, b);
    UDch3.position:= Ch3; UDch3Click(p, b);
    UDch4.position:= Ch4; UDch4Click(p, b);
    UDch5.position:= Ch5; UDch5Click(p, b);
    UDch6.position:= Ch6; UDch6Click(p, b);
    UDch7.position:= Ch7; UDch7Click(p, b);
    UDch8.position:= Ch8; UDch8Click(p, b);
    UDEffect.position:= ChEffect; UDEffectClick(p, b);
    UDCenter.position:= ChCenter; UDCenterClick(p, b);
    UDExtra.position:= ChExtra; UDExtraClick(p, b);
    UDBas.position:= ChBas; UDBasClick(p, b);
    UDMid.position:= ChMid; UDMidClick(p, b);
    TbxControlIP.text:= ControlIP;
  end;
end;

procedure TFrmMain.FormDestroy(Sender: TObject);
begin
  WriteSettings;
end;

procedure TFrmMain.FormCreate(Sender: TObject);
var OSstring, ExeDir: shortstring;
begin
{$IFDEF Linux}
  OSstring:= 'Linux';
{$ENDIF}
{$IFDEF WINDOWS}
  OSstring:= 'Windows';
{$ENDIF}                  
  Caption:= 'Configuration Tool v: ' + VERSIONSTRING + ' on: ' + OSstring;
  ExeDir:= application.Location; // directory of executable
  SettingsFilename:= ExeDir + 'Settings.txt';        
  ReadSettings;
end;

end.

